#include "spesa.h"

Spesa readSpesa(FILE * fp)
{
	Spesa result;
	char dataTemp[11];
	
	readField(dataTemp, ' ', fp);
	result.data = longStringToDate(dataTemp);

	readField(result.ccNumber, ' ', fp);
	
	fscanf(fp, "%f", &(result.import));
	fgetc(fp);

	readField(result.valuta, ' ', fp);

	readField(result.description, '@', fp);

	return result;
}


list readSpese(char * fileName)
{
	FILE * fp;
	list result = emptyList();

	if ( (fp=fopen(fileName, "r")) == 0)
		return result;

	while (!feof(fp))
		result = cons(readSpesa(fp), result);
	
	fclose(fp);
	return result;
}

void printSpesa(Spesa s)
{
	printf("%d/%d/%d %s %f %s %s\n",
		s.data.day,
		s.data.month,
		s.data.year,
		s.ccNumber,
		s.import,
		s.valuta,
		s.description );
}

void printSpese(list l)
{
	if (isEmpty(l))
		return;
	else
	{
		printSpesa(head(l));
		printSpese(tail(l));
	}
	return;
}


int insert(Spesa intArray[], Spesa el, int dim, int *elCount)
{
	int i = 0, j;
	int found = 0;
	
	if (*elCount < dim)
	{
		while (i < *elCount && !found)
		{
			if (compare( el.data, intArray[i].data)<=0)
				found = 1;
			else
				i++;
		}
		if (found)
			for(j = *elCount; j >= i; j--)
				intArray[j] = intArray[j - 1];
		intArray[i] = el;
		(*elCount)++;
		return 1;
	}
	return 0;
}

Spesa * selectSpese(Cliente c, list l, int * dim)
{
	int initDim = 0;
	Spesa * result;
	list temp = l;

	*dim = 0;

	while (!isEmpty(temp))
	{
		if (strcmp(c.ccNumber , head(temp).ccNumber) ==0)
			(*dim)++;
		temp = tail(temp);
	}

	result = (Spesa *) malloc (*dim * sizeof(Spesa));
	
	while (!isEmpty(l) && initDim<=*dim)
	{
		while (!isEmpty(l) && strcmp(c.ccNumber , head(l).ccNumber) !=0)
			l=tail(l);
		if (!isEmpty(l))
		{
			insert(result, head(l),*dim, &initDim);
			l = tail(l);
		}
	}
	return result;
}






list emptyList()
{
	return NULL;
}

list cons(Spesa newValue, list l)
{
	item * temp = (item *) malloc (sizeof(item));
	temp->value = newValue;
	temp->next = l;
	return temp;
}

Spesa head(list l)
{
	return l->value;
}

list tail(list l)
{
	return l->next;
}

int isEmpty(list l)
{
	return l == NULL;
}